checkRequire("Lua_MarryAttrsListItem");
Lua_MarryChildInfoPanel = class("Lua_MarryChildInfoPanel", Lua_DisplayObject);
function Lua_MarryChildInfoPanel:ctor(p)
	self:superCall("ctor", p, "MarryChildInfoPanel_skin", true);
end

function Lua_MarryChildInfoPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.btnList = Lua_DragSecButtonList.new(self.content, Vector4(0, -290, 300, 580), self, self.onButtonListClick);
	self.btnList:setMainBtnCell(Lua_MarryChildrenMainCell, 300, 56, 0, 0);
	self.btnList:setSecBtnCell(Lua_MarryChildrenSecCell, 286, 106, 0, 0);
	self.btnList:setLocation(-460, 257, 0);
	self.btnList:setDepth(5);

	local skill;
	self.skillArr = Array();
	for i = 1, 5 do
		skill = Lua_MarryChildSkillItem.new(self.content);
		skill:setLocation(-187 + ( i - 1) * 75, -258, 0)
		self.skillArr:add(skill);
	end

	self.fightNum = Lua_NumberImage.new(self.content);
	self.fightNum.numWidth = 13;
	self.fightNum.numAtlas = "number_atlas";
	self.fightNum:setDepth(6);
	self.fightNum:setLocation(374, 232, 0);

	self.attrsList = Lua_DragList.new(self.content, 1, Vector4(0, 0, 280, 180));
	self.attrsList:setLocation(367, 65, 0);
	self.attrsList:setListCell(Lua_MarryAttrsListItem, 30, 40, 1);

	self.mainBtn:addClickFuntion(self, self.onMainBtnClick);
	self.upgradeBg:addClickFuntion(self, self.onUpgradeBtnClick);
	self.fightBg:addClickFuntion(self, self.onFightBtnClick);
	self.hideBox:addBoxChange(self, self.onHideBoxChange);
	self.solveBtn:addClickFuntion(self, self.onSolveBtnClick);

	self.bNoShowModel = false;
	self.noActiveSign:SetActive(false);
	self.mainBtnRedDot:setEnable(false);

	self:updateUpgradeRedDot();

	self:addLuaEvent("rMarryChildrenInfo", self, self.updateChildrenShowInfo);
	self:addLuaEvent("rChildrenUpgradeJie", self, self.onChildrenUpgradeJie);
	self:addLuaEvent("MarryChildrenSelectShowVo", self, self.onShowSelectChildVo);
	self:addLuaEvent("MarryChildUpgradeWindowShowOrHide", self, self.onCheckShowModel);
	self:addLuaEvent("PACK_UPDATE", self, self.onPackDataUpdate);
	self:addLuaEvent("UPDATE_REDDOT_EVENT", self, self.onRedDotUpdate);
	Lua_ProxyManager.getProxy("Lua_MarryNewProxy"):sMarryChildrenInfo();
end

-- 红点更新
function Lua_MarryChildInfoPanel:onRedDotUpdate(obj)
	if obj ~= nil then
		if obj.evenId == 11602 or obj.evenId == 11603 then -- 仙娃激活红点/仙娃升阶红点
			self:updateChildrenShowInfo();
		elseif obj.evenId == 11604 or obj.evenId == 11605 then -- 仙娃分解红点/仙娃升级红点
			self:updateUpgradeRedDot();
		end
	end
end

-- 更新升级按钮的红点
function Lua_MarryChildInfoPanel:updateUpgradeRedDot()
	local bShow = DataCenter.redDotData:getRedDotStateByEventId(11604);
	if bShow == false then
		bShow = DataCenter.redDotData:getRedDotStateByEventId(11605);
	end
	self.upgradeRedDot:setEnable(bShow);
end

-- 背包更新
function Lua_MarryChildInfoPanel:onPackDataUpdate(packType)
	if packType == Lua_PackData.BAG_PACK then
		if self.showVo == nil  then
			return;
		end

		if self.showVo.bActive == true then
			if self.upgradeIcon ~= nil then
				local num = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK):getItemNum(self.showVo.gradeCostItemId);
				self.upgradeIcon:showNumLimit(num, 1, 2);

				local vo = DataCenter.marryNewUtil:getChildGradeVo(self.showVo.id, self.showVo.grade);
				if vo ~= nil then
					local nextGradeVo = DataCenter.marryNewUtil:getChildGradeVo(self.showVo.id, self.showVo.grade + 1);
					if nextGradeVo == nil then -- 等阶最大了
						self.mainBtn:setGray(true);
						self.mainBtnRedDot:setEnable(false);
					else
						self.mainBtn:setGray(false);
						self.mainBtnRedDot:setEnable(self.showVo:checkUpgrade(false));
					end
				end
			end
		else
			if self.showVo.activeCostItemVo ~= nil then
				self:updateActiveCondition();
				if self.showVo:checkActive(false) == true then
					self.mainBtnRedDot:setEnable(true);
					self.mainBtn:setGray(false);
				else
					self.mainBtnRedDot:setEnable(false);
					self.mainBtn:setGray(true);
				end
			end
		end
	end
end

function Lua_MarryChildInfoPanel:onChildrenUpgradeJie(err)
	if err == 0 then
		if self.autoUpgradeId ~= nil then
			if self.showVo:checkUpgrade(true) == true then
				Lua_ProxyManager.getProxy("Lua_MarryNewProxy"):sChildrenUpgradeJie(self.autoUpgradeId);
			else
				self.autoUpgradeId = nil;
				self.mainBtn.label = LanUtil.getValue(144019);
			end
		end
	else -- 报错，停止升级
		self.autoUpgradeId = nil;
		self.mainBtn.label = LanUtil.getValue(144019);
	end
end

function Lua_MarryChildInfoPanel:onMainBtnClick(go)
	if self.showVo == nil then
		OperateAlert.show(LanUtil.getValue(144016));
		return;
	end

	if self.showVo.bActive == false then -- 激活
		if self.showVo:checkActive(true) == true then
			Lua_ProxyManager.getProxy("Lua_MarryNewProxy"):sActiveChildren(self.showVo.id);
		end
	else -- 升阶
		if self.showVo:checkUpgrade(true) == true then
			if self.autoUpgradeId == nil then
				self.autoUpgradeId = self.showVo.id;
				self.mainBtn.label = LanUtil.getValue(144050);
			else
				self.autoUpgradeId = nil;
				self.mainBtn.label = LanUtil.getValue(144019);
			end
			Lua_ProxyManager.getProxy("Lua_MarryNewProxy"):sChildrenUpgradeJie(self.showVo.id);
		end
	end
end

-- 升级
function Lua_MarryChildInfoPanel:onUpgradeBtnClick(go)
	self.autoUpgradeId = nil;
	if self.showVo ~= nil then
		Lua_WindowUtil.openWin("Lua_MarryChildUpgradeWindow", WinParam.ACTION_OPEN, self.showVo);
	end
end

-- 出战
function Lua_MarryChildInfoPanel:onFightBtnClick(go)
	if self.showVo == nil then
		OperateAlert.show(LanUtil.getValue(144017));
		return;
	end
	if self.showVo.id == DataCenter.marryNewData.marryFightChildrenId then
		OperateAlert.show(LanUtil.getValue(144018));
		return;
	end
	Lua_ProxyManager.getProxy("Lua_MarryNewProxy"):sChangeChildFightState(self.showVo.id, 1);
end

-- 隐藏
function Lua_MarryChildInfoPanel:onHideBoxChange(val)
	if val == true then
		Lua_ProxyManager.getProxy("Lua_MarryNewProxy"):sShowHideChildren(0);
	else
		Lua_ProxyManager.getProxy("Lua_MarryNewProxy"):sShowHideChildren(1);
	end
end

-- 通过道具默认显示
function Lua_MarryChildInfoPanel:setDefaultShowTvo(tvo)
	self.defaultShowTvo = tvo;
end

-- 通过类型默认显示 1可激活 2 可进阶(升級)
function Lua_MarryChildInfoPanel:setDefaultShowType(defaulttype)
	self.defaultShowType = defaulttype;
end

function Lua_MarryChildInfoPanel:onSolveBtnClick(go)
	Lua_WindowUtil.openWin("Lua_MarryChildSolveWindow", WinParam.ACTION_OPEN);
end

function Lua_MarryChildInfoPanel:updateChildrenShowInfo(isRedRefresh)
	local arr = DataCenter.marryNewUtil.marryChildrenTitleList;
	-- 有激活 > 可进阶 > 出战 > 第一个
	if self.showVo == nil then
		if self.defaultShowTvo == nil then
			local isAct, isJinJie, isFight, childVo, mainIdx, subIdx = false, false, false, nil, 1, 1;
			for i = 1, arr:getSize() do
				for j = 1, arr[i].sub:getSize() do
					childVo = arr[i].sub[j];
					if childVo.bActive then -- 已激活
						if not isJinJie and childVo:checkUpgrade(false) then -- 可升級
							isJinJie = true;
							mainIdx = i;
							subIdx = j;
							if self.defaultShowType == 2 then
								break;
							end
						elseif not isJinJie and not isFight and childVo.id == DataCenter.marryNewData.marryFightChildrenId then -- 已出战
							isFight = true;
							mainIdx = i;
							subIdx = j;
						end
					else
						if childVo:checkActive(false) then -- 可激活
							isAct = true;
							mainIdx = i;
							subIdx = j;
							if self.defaultShowType ~= 2 then
								break;
							end
						end
					end
				end
				if (self.defaultShowType ~= 2 and isAct) or (self.defaultShowType == 2 and isJinJie) then
					break;
				end
			end
			-- print(isAct, isJinJie, isFight, mainIdx, subIdx);
			self.btnList:setData(arr, mainIdx, subIdx);
		else	
			local childVo;
			for i = 1, arr:getSize() do
				for j = 1, arr[i].sub:getSize() do
					childVo = arr[i].sub[j];
					if childVo.itemId == self.defaultShowTvo.id then
						self.btnList:setData(arr, i, j);
						self.defaultShowTvo = nil;
						return;
					end
				end
			end
			self.btnList:setData(arr, 1, 1);
		end
	else
		self.btnList:setData(arr);
	end
end

function Lua_MarryChildInfoPanel:onShowSelectChildVo(vo)
	if self.autoUpgradeId ~= nil and self.autoUpgradeId ~= vo.id then
		self.autoUpgradeId = nil;
	end

	self.showVo = vo;
	self:showModel();
	self:updateActiveCondition();
	if vo ~= nil then
		self.nameTxt.text = vo.name;
		self.fightNum.num = vo.force;
		local strArr = string.split(LanUtil.getValue(110507), ",");
		local str = string.split(LanUtil.getValue(110508), ",")[1];
		self.jieTxt.text = strArr[vo.grade + 1]..str;
		if vo.bActive == true then -- 激活
			self.jihuoDescTxt.text = "";
			local gradeVo = DataCenter.marryNewUtil:getChildGradeVo(vo.id, vo.grade);
			if gradeVo ~= nil then
				self.descTxt.text = gradeVo.desc;
			end
			self.jihuoJinjieTxt.text = LanUtil.getValue(144020);
			self.noActiveSign:SetActive(false);
			self.upgradeSpr:SetActive(true);
			self:updateChildUpgradeInfo();

			if self.autoUpgradeId == nil or self.autoUpgradeId ~= vo.id then
				self.mainBtn.label = LanUtil.getValue(144019);
			else
				self.mainBtn.label = LanUtil.getValue(144050);
			end
		else -- 未激活
			self.mainBtn.label = LanUtil.getValue(144021);
			self.jihuoDescTxt.text = vo.sourceStr;
			self.descTxt.text = "";
			self.jihuoJinjieTxt.text = LanUtil.getValue(144022);
			self.noActiveSign:SetActive(true);
			self.upgradeSpr:SetActive(false);
			if self.showVo:checkActive(false) == true then
				self.mainBtnRedDot:setEnable(true);
				self.mainBtn:setGray(false);
			else
				self.mainBtnRedDot:setEnable(false);
				self.mainBtn:setGray(true);
			end
		end

		-- 更新技能栏
		local arr = Array();
		local len = self.showVo.skillArr:getSize();
		for i = 1, len do
			arr:add(self.showVo.skillArr[i]);
		end

		while (len < 5) do
			len = len + 1;
			arr:add(len);
		end

		for i = 1, self.skillArr:getSize() do
			self.skillArr[i]:setData(arr[i]);
		end
		self:updateAttrs();
	end
end

function Lua_MarryChildInfoPanel:onCheckShowModel(val)
	self.bNoShowModel = val;
	if val == true then
		if self.modelTexture ~= nil then
			self.curModelId = nil;
			self.modelTexture:dispose();
			self.modelTexture = nil;
		end
	else
		self:showModel();
	end
end

function Lua_MarryChildInfoPanel:showModel()
	if self.showVo == nil or self.bNoShowModel == true then
		if self.modelTexture ~= nil then
			self.modelTexture:dispose();
			self.modelTexture = nil;
		end
		return;
	end

	-- 这部分太多代码，参考侍宠的，有空优化
	if self.modelTexture == nil then
		self.modelTexture = UIModelTexture();
		self.modelTexture:init(self.content, Vector2(5, -30), Vector2(1175, 680), 3, Vector3(0, 180, 0), Vector2(-50, -130), 360);
		self.modelTexture:setRotEnable(true, -31, 69, 250, 350, 2);
		self.rootPos = self.modelTexture.root.transform.localPosition;
		self.rootRot = self.modelTexture.root.transform.localEulerAngles;
		self.rootSca = self.modelTexture.root.transform.localScale;
		self.effectPos = self.modelTexture.uiEffect.mainContent.transform.localPosition;
		self.effectRot = self.modelTexture.uiEffect.mainContent.transform.localEulerAngles;
		self.effectSca = self.modelTexture.uiEffect.mainContent.transform.localScale;
	end
    
	if self.curModelId ~= self.showVo.shapeId then
		self.curModelId = self.showVo.shapeId;
		local modelInfo = DataCenter.servantData:getModelInfo(self.showVo.shapeId);
		if modelInfo == nil then
			if self.modelTexture ~= nil then
				self.modelTexture:dispose();
				self.modelTexture = nil;
			end
			return;
		end
		self.modelTexture:setUrl(modelInfo.floder .. "/" .. modelInfo.fileName, tostring(modelInfo.modelName));

		local rootPos = nil;
		if modelInfo.rootPos == nil then
			rootPos = self.rootPos;
		else
			rootPos = Vector3(modelInfo.rootPos[1], modelInfo.rootPos[2], modelInfo.rootPos[3]);
		end

		local rootRot = nil;
		if modelInfo.rootRot == nil then
			rootRot = self.rootRot;
		else
			rootRot = Vector3(modelInfo.rootRot[1], modelInfo.rootRot[2], modelInfo.rootRot[3]);
		end

		local rootSca = nil;
		if modelInfo.rootSca == nil then
			rootSca = self.rootSca;
		else
			rootSca = Vector3(modelInfo.rootSca[1], modelInfo.rootSca[2], modelInfo.rootSca[3]);
		end

		local effectPos = nil;
		if modelInfo.pos == nil then
			effectPos = self.effectPos;
		else
			effectPos = Vector3(modelInfo.pos[1], modelInfo.pos[2], modelInfo.pos[3]);
		end

		local effectRot = nil;
		if modelInfo.rot == nil then
			effectRot = self.effectRot;
		else
			effectRot = Vector3(modelInfo.rot[1], modelInfo.rot[2], modelInfo.rot[3]);
		end

		local effectSca = nil;
		if modelInfo.sca == nil then
			effectSca = self.effectSca;
		else
			effectSca = Vector3(modelInfo.sca[1], modelInfo.sca[2], modelInfo.sca[3]);
		end

		self.modelTexture:setEffectPos(effectPos.x, effectPos.y, effectPos.z);
		self.modelTexture:setModelAngle(effectRot.x, effectRot.y, effectRot.z);
		self.modelTexture:setModelOffset(rootPos.x, rootPos.y, rootPos.z);
		self.modelTexture.uiEffect:setSacle(effectSca.x, effectSca.y, effectSca.z);
		-- self.modelTexture.root.transform.localEulerAngles = rootRot;
		-- self.modelTexture.root.transform.localScale = rootSca;
	    LuaUtil.setObjRot(self.modelTexture.root, rootRot.x, rootRot.y, rootRot.z);
		LuaUtil.setObjScale(self.modelTexture.root, rootSca.x, rootSca.y, rootSca.z);
	end
	self.modelTexture.uiEffect:setGray(not self.showVo.bActive);
end

function Lua_MarryChildInfoPanel:updateAttrs()
	if self.showVo == nil then
		return;
	end

	local list;
	local arr = Array();
	local gradeVo = DataCenter.marryNewUtil:getChildGradeVo(self.showVo.id, self.showVo.grade);
	if self.showVo.bActive == false then -- 未激活
		list = gradeVo.attrsArr;
		for i = 1, list:getSize() do
			arr:add({name = list[i].name, curValue = 0, nextValue = list[i].value});
		end
	else
		local nextGradeVo = DataCenter.marryNewUtil:getChildGradeVo(self.showVo.id, self.showVo.grade + 1);
		if nextGradeVo == nil then -- 等阶最大了
			list = gradeVo.attrsArr;
			for i = 1, list:getSize() do
				arr:add({name = list[i].name, curValue = list[i].value, nextValue = 0});
			end
		else -- 有下一阶
			list = gradeVo.attrsArr;
			local num;
			for i = 1, list:getSize() do
				num = nextGradeVo.attrsDic[list[i].name];
				num = num ~= nil and num - list[i].value or 0;
				arr:add({name = list[i].name, curValue = list[i].value, nextValue = num});
			end

			-- 防止下一阶有，而当前阶没有情况
			list = nextGradeVo.attrsArr;
			for i = 1, list:getSize() do
				num = gradeVo.attrsDic[list[i].name];
				if num == nil then
					arr:add({name = list[i].name, curValue = 0, nextValue = list[i].value});
				end
			end
		end
	end
	self.attrsList:setLuaArrayData(arr, false);
end

function Lua_MarryChildInfoPanel:updateActiveCondition()
	if self.showVo == nil or self.showVo.bActive == true then
		if self.activeContainer ~= nil then
			self.activeContainer:dispose();
			self.activeContainer = nil;
		end
		return;
	end

	if self.activeContainer == nil then
		self.activeContainer = Lua_DragContainer.new(self.content, 2, Vector4(120, -60, 260, 150));
		self.activeContainer.uiPanel.depth = 3000;
		self.activeContainer.canDrag = false;
	end
	self.activeContainer:removeAllChildren();

	-- 信物等级要求
	local item;
	local preWidth = 0;
	if self.showVo.activeNeedKeepsakeLv > 0 then
		local keepsakeInfo = DataCenter.marryNewData.keepsakeInfo;
		item = Lua_MarryChildActiveKeepsake.new(self.activeContainer.sub);
		if keepsakeInfo == nil then
			item:setData(0, 0, self.showVo.activeNeedKeepsakeLv);
		else
			item:setData(keepsakeInfo.keepsake_lvl, DataCenter.marryNewData.spouseKeepsakeLv, self.showVo.activeNeedKeepsakeLv);
		end
		preWidth = preWidth + item:getWidth();
		self.activeContainer:addSubContainer(item, false);
	end

	-- 消耗道具要求
	if self.showVo.activeCostItemVo ~= nil then
		if preWidth > 0 then -- 添加【或】
			item = Lua_MarryChildActiveGradeOrItem.new(self.activeContainer.sub);
			item:setData(nil, Lua_MarryChildActiveGradeOrItem.COSTTYPE_OR);
			preWidth = preWidth + item:getWidth();
			self.activeContainer:addSubContainer(item, false);
		end

		item = Lua_MarryChildActiveGradeOrItem.new(self.activeContainer.sub);
		item:setData(self.showVo.activeCostItemVo, Lua_MarryChildActiveGradeOrItem.COSTTYPE_ITEM);
		preWidth = preWidth + item:getWidth();
		self.activeContainer:addSubContainer(item, false);
	end

	-- 对应仙娃等阶要求
	if self.showVo.activeNeedChildVo ~= nil then
		-- local vo = DataCenter.marryNewUtil.marryChildrenInfo[self.showVo.activeNeedChildVo.id];
		-- if vo ~= nil then
			if preWidth > 0 then -- 添加【或】
				item = Lua_MarryChildActiveGradeOrItem.new(self.activeContainer.sub);
				item:setData(nil, Lua_MarryChildActiveGradeOrItem.COSTTYPE_OR);
				preWidth = preWidth + item:getWidth();
				self.activeContainer:addSubContainer(item, false);
			end
			item = Lua_MarryChildActiveGradeOrItem.new(self.activeContainer.sub);
			item:setData(self.showVo.activeNeedChildVo, Lua_MarryChildActiveGradeOrItem.COSTTYPE_GRADE);
			preWidth = preWidth + item:getWidth();
			self.activeContainer:addSubContainer(item, false);
		-- end
	end

	self.activeContainer:updateChildPos(); 
	self.activeContainer:setLocation(370 - preWidth / 2, -105, 0);
end

function Lua_MarryChildInfoPanel:updateChildUpgradeInfo()
	self.hideBox.seleted = not DataCenter.marryNewData.bMarryChildrenWear;
	if self.showVo ~= nil and self.showVo.bActive == true then
		self.fightBg:setEnable(self.showVo.id ~= DataCenter.marryNewData.marryFightChildrenId);

		if self.upgradeIcon == nil then
			self.upgradeIcon = Lua_ToolImage.new(self.upgradeSpr);
			self.upgradeIcon:setDepth(4);
			self.upgradeIcon:setLocation(360, -130, 0);
		end
		local vo = Lua_ToolVo.createToolVo(self.showVo.gradeCostItemId, 1);
		self.upgradeIcon.data = vo;
		local num = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK):getItemNum(vo.id);
		self.upgradeIcon:showNumLimit(num, vo.count, 2);

		vo = DataCenter.marryNewUtil:getChildGradeVo(self.showVo.id, self.showVo.grade);
		if vo ~= nil then
			local nextGradeVo = DataCenter.marryNewUtil:getChildGradeVo(self.showVo.id, self.showVo.grade + 1);
			if nextGradeVo == nil then -- 等阶最大了
				self.upgradeBar:setText("MAX");
				self.upgradeBar:setMaxValue(1);
				self.upgradeBar:setValue(1);
				self.mainBtn:setGray(true);
				self.mainBtnRedDot:setEnable(false);
			else
				self.mainBtnRedDot:setEnable(self.showVo:checkUpgrade(false));
				self.upgradeBar:setText(self.showVo.gradeExp.."/"..vo.upgradeExp);
				self.upgradeBar:setMaxValue(vo.upgradeExp);
				self.upgradeBar:setValue(self.showVo.gradeExp);
				self.mainBtn:setGray(false);
			end
		end
	end
end

function Lua_MarryChildInfoPanel:dispose()
	if self.btnList ~= nil then
		self.btnList:dispose();
		self.btnList = nil;
	end
	if self.skillArr ~= nil then
		self.skillArr:dispose();
		self.skillArr:clear();
		self.skillArr = nil;
	end
	if self.fightNum ~= nil then
		self.fightNum:dispose();
		self.fightNum = nil;
	end
	if self.attrsList ~= nil then
		self.attrsList:dispose();
		self.attrsList = nil;
	end
	if self.modelTexture ~= nil then
		self.modelTexture:dispose();
		self.modelTexture = nil;
	end
	if self.activeContainer ~= nil then
		self.activeContainer:dispose();
		self.activeContainer = nil;
	end
	if self.upgradeIcon ~= nil then
		self.upgradeIcon:dispose();
		self.upgradeIcon = nil;
	end

	self.bNoShowModel = false;
	self.autoUpgradeId = nil;
	self:superCall("dispose");
end





--------------------------------------------------





-- 仙娃列表的一级item
Lua_MarryChildrenMainCell = class("Lua_MarryChildrenMainCell", Lua_DragSecBtnListCell);
function Lua_MarryChildrenMainCell:ctor(p, t, cellWidth, cellHeight, offsetX, offsetY, skin)
	self:superCall("ctor", p, t, cellWidth, cellHeight, offsetX, offsetY, "MarryChildrenMainCell_skin");
end

function Lua_MarryChildrenMainCell:buildShowItem()
	self:superCall("buildShowItem");

	self.redDot:setEnable(false);
	self.arrow:setRot(0, 0, 90);
end

function Lua_MarryChildrenMainCell:updateData()
	if self.data ~= nil then
		self.txt.text = self.data.name;

		local bShow = DataCenter.redDotData:getRedDotStateByEventId(11602);
		if bShow == false then
			bShow = DataCenter.redDotData:getRedDotStateByEventId(11603);
		end

		if bShow == false then -- 激活和升阶都没红点就不进行逻辑处理了
			self.redDot:setEnable(false);
		else
			bShow = false;
			local arr = self.data.sub;
			if arr ~= nil and arr:getSize() > 0 then
				local len = arr:getSize();
				for i = 1, len do
					if arr[i] ~= nil and (arr[i]:checkActive(false) == true or arr[i]:checkUpgrade(false) == true) then
						bShow = true;
						break;
					end
				end
			end
			self.redDot:setEnable(bShow);
		end
	end
end

function Lua_MarryChildrenMainCell:setSelected(val)
	if val ~= self._selected then
		if val == true then
			self.bg:setAltas("common_atlas_2", "ui_common_widget_x5"); -- 展开
			self.arrow:setRot(0, 0, 0);
		else
			self.bg:setAltas("common_atlas_2", "ui_common_widget_x5"); -- 不展开
			self.arrow:setRot(0, 0, 90);
		end
	end
	self._selected = val;
end

function Lua_MarryChildrenMainCell:dispose()
	self:superCall("dispose");
end





--------------------------------------------------





-- 仙娃列表的二级item
Lua_MarryChildrenSecCell = class("Lua_MarryChildrenSecCell", Lua_DragSecBtnListCell);
function Lua_MarryChildrenSecCell:ctor(p, t, cellWidth, cellHeight, offsetX, offsetY, skin)
	self:superCall("ctor", p, t, cellWidth, cellHeight, offsetX, offsetY, "MarryChildrenSecCell_skin");
end

function Lua_MarryChildrenSecCell:buildShowItem()
	self:superCall("buildShowItem");

	self.redDot:setEnable(false);
end

function Lua_MarryChildrenSecCell:updateData()
	if self.data ~= nil then
		self.nameTxt.text = self.data.name;
		if self.data.bActive == true then
			local strArr = string.split(LanUtil.getValue(110507), ",");
			local str = string.split(LanUtil.getValue(110508), ",")[1];
			self.descTxt.text = strArr[self.data.grade + 1] .. str;

			self.redDot:setEnable(self.data:checkUpgrade(false));
		else
			if self.data:checkActive(false) == true then -- 可激活
				self.descTxt.text = LanUtil.getValue(144023);
			else
				self.descTxt.text = LanUtil.getValue(144024);
			end
			self.redDot:setEnable(self.data:checkActive(false));
		end
		self.descBg:setEnable(self.data.bActive);
		self.signSpr:SetActive(self.data.bOutFighting);

		self.headBg:setAltas("common_atlas_1", "ui_common_prop_" .. self.data.color + 1);
		if self.data.headSrc ~= nil and self.data.headSrc ~= "" and self.headSrc ~= self.data.headSrc then
			self.headSrc = self.data.headSrc;
			self.headImg:setUrl("/images/head/baby/"..tostring(self.headSrc));
		end
		self.headBg:setGray(not self.data.bActive);
		self.headImg:setGray(not self.data.bActive);
	else
		self.redDot:setEnable(false);
	end
end

function Lua_MarryChildrenSecCell:setSelected(val)
	if val ~= self._selected then
		if val == true then
			self.bg:setAltas("common_atlas_1", "ui_common_widget_x1");
			if self.data.bActive then
				self.descBg:setAltas("common_atlas_2", "ui_common_title_7");
			end
		else
			self.bg:setAltas("common_atlas_1", "ui_common_widget_x2");
			if self.data.bActive then
				self.descBg:setAltas("common_atlas_2", "ui_common_title_8");
			end
		end

		if val == true then
			Lua_MsgUtil.callFunc("MarryChildrenSelectShowVo", self.data);
		end
	else
		if val == true and self.bRefreshData == true then
			self.bRefreshData = false;
			Lua_MsgUtil.callFunc("MarryChildrenSelectShowVo", self.data);
		end
	end
	self._selected = val;
end

function Lua_MarryChildrenSecCell:dispose()
	self:superCall("dispose");
end





--------------------------------------------------





-- 技能item
Lua_MarryChildSkillItem = class("Lua_MarryChildSkillItem", Lua_DisplayObject);
function Lua_MarryChildSkillItem:ctor(p)
	self:superCall("ctor", p, "MarryChildSkillItem_skin");
end

function Lua_MarryChildSkillItem:buildShowItem()
	self:superCall("buildShowItem");

	self.skillImg.clickScale = false;
	self.skillImg:addClickFuntion(self, self.onPlayerSoundClick);
end

function Lua_MarryChildSkillItem:dispose()
	self:superCall("dispose");
end

function Lua_MarryChildSkillItem:setData(data)
	self.data = data;
	if data == nil then
		return;
	end

	if type(data) == "number" then
		self.skillImg:setEnable(false);
		self.lockImg:setEnable(true);
	else
		self.skillImg:setEnable(true);
		self.lockImg:setEnable(false);
		self.skillImg:setAltas(data.atlasName, data.iconName);
		self.skillImg:setGray(data.skillLv <= 0);
	end
end

function Lua_MarryChildSkillItem:onPlayerSoundClick(go)
	if self.data ~= nil and type(self.data) ~= "number" then
		-- 显示技能tips
		Lua_WindowUtil.openWin("Lua_MarryChildrenSkillDetailWindow", WinParam.ACTION_OPEN, self.data);
	end
end





--------------------------------------------------





-- 激活条件之信物等级要求
Lua_MarryChildActiveKeepsake = class("Lua_MarryChildActiveKeepsake", Lua_DragContainerItem);
function Lua_MarryChildActiveKeepsake:ctor(p)
	self:superCall("ctor", p, "MarryChildActiveKeepsake_skin");
end

function Lua_MarryChildActiveKeepsake:buildShowItem()
	self:superCall("buildShowItem");
end

function Lua_MarryChildActiveKeepsake:setData(curLv, spouseLv, maxLv)
	if DataCenter.roleData.sex == Lua_ThingDefine.MALE then
		if curLv < maxLv then
			self.boyTxt.text = "[FF1616]"..curLv.."/"..maxLv.."[-]";
		else
			self.boyTxt.text = "[00E125]"..curLv.."/"..maxLv.."[-]";
		end

		if spouseLv < maxLv then
			self.girlTxt.text = "[FF1616]"..spouseLv.."/"..maxLv.."[-]";
		else
			self.girlTxt.text = "[00E125]"..spouseLv.."/"..maxLv.."[-]";
		end
	else
		if curLv < maxLv then
			self.girlTxt.text = "[FF1616]"..curLv.."/"..maxLv.."[-]";
		else
			self.girlTxt.text = "[00E125]"..curLv.."/"..maxLv.."[-]";
		end

		if spouseLv < maxLv then
			self.boyTxt.text = "[FF1616]"..spouseLv.."/"..maxLv.."[-]";
		else
			self.boyTxt.text = "[00E125]"..spouseLv.."/"..maxLv.."[-]";
		end
	end
end

function Lua_MarryChildActiveKeepsake:getHeight()
	return 100;
end

function Lua_MarryChildActiveKeepsake:getWidth()
	return 90;
end

function Lua_MarryChildActiveKeepsake:dispose()
	self:superCall("dispose");
end





--------------------------------------------------





-- 激活条件之消耗道具或对应仙娃等阶要求
Lua_MarryChildActiveGradeOrItem = class("Lua_MarryChildActiveGradeOrItem", Lua_DragContainerItem);
Lua_MarryChildActiveGradeOrItem.COSTTYPE_ITEM = 1;
Lua_MarryChildActiveGradeOrItem.COSTTYPE_GRADE = 2;
Lua_MarryChildActiveGradeOrItem.COSTTYPE_OR = 3;
function Lua_MarryChildActiveGradeOrItem:ctor(p)
	self:superCall("ctor", p, "MarryChildActiveGrade_skin");
end

function Lua_MarryChildActiveGradeOrItem:buildShowItem()
	self:superCall("buildShowItem");
end

-- costType 1 道具  2 等阶要求
function Lua_MarryChildActiveGradeOrItem:setData(vo, costType)
	self.costType = costType;

	if costType == Lua_MarryChildActiveGradeOrItem.COSTTYPE_ITEM then
		self.txt.text = LanUtil.getValue(144025);
		self.txt:setLocation(0, 0, 0);

		local num = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK):getItemNum(vo.id);
		self.item = Lua_ToolImage.new(self.content);
		self.item:setDepth(3);
		self.item:setLocation(40, -75, 0);
		self.item.data = vo;
		self.item:showNumLimit(num, vo.count, 2);
	elseif costType == Lua_MarryChildActiveGradeOrItem.COSTTYPE_GRADE then
		local activeVo = DataCenter.marryNewUtil.marryChildrenInfo[vo.id];
		local str = string.split(LanUtil.getValue(110508), ",")[1];
		str = vo.grade..str;
		if activeVo ~= nil and activeVo.grade >= vo.grade then
			str = Lua_ColorDefine.colorStr(str, Lua_ColorDefine.GREEN_STR);
		else
			str = Lua_ColorDefine.colorStr(str, Lua_ColorDefine.RED_STR);
		end
		self.txt.text = LanUtil.formateStr(LanUtil.getValue(144026), vo.name, str);
		self.txt:setLocation(0, 0, 0);

		if self.item ~= nil then
			self.item:dispose();
			self.item = nil;
		end
	else
		self.txt.text = LanUtil.getValue(144027);
		self.txt:setLocation(0, -70);

		if self.item ~= nil then
			self.item:dispose();
			self.item = nil;
		end
	end
end

function Lua_MarryChildActiveGradeOrItem:getHeight()
	return 100;
end

function Lua_MarryChildActiveGradeOrItem:getWidth()
	if self.costType == Lua_MarryChildActiveGradeOrItem.COSTTYPE_ITEM then
		return 90;
	elseif self.costType == Lua_MarryChildActiveGradeOrItem.COSTTYPE_GRADE then
		return self.txt.widget.width;
	else
		return 30;
	end
	return 90;
end

function Lua_MarryChildActiveGradeOrItem:dispose()
	if self.item ~= nil then
		self.item:dispose();
		self.item = nil;
	end

	self:superCall("dispose");
end