-- 姻缘仙娃分解界面
Lua_MarryChildSolveWindow = class("Lua_MarryChildSolveWindow", Lua_Window);
function Lua_MarryChildSolveWindow:ctor(p)
	self:superCall("ctor", p);

	self.windowName = "Lua_MarryChildSolveWindow";
	self.skinName = "MarryChildSolveWindow_skin";
end

function Lua_MarryChildSolveWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.itemList = Lua_DragList.new(self.content, 1, Vector4(0, 0, 812, 312));
	self.itemList:setListCell(Lua_ChildrenSolveListItem, 104, 116, 7);

	self.helpTxt.text = LanUtil.getValue(144048);

	self.addExp = 0;
	self.expTxt.text = LanUtil.formateStr(LanUtil.getValue(144031), "[FF1616]"..self.addExp.."[-]");
	self:updateItemList();

	-- self.helpImg:addClickFuntion(self, self.onHelpImgClick);
	self.selectBox:addBoxChange(self, self.onSelectBoxChange);
	self.solveBtn:addClickFuntion(self, self.onSolveBtnClick);
	self:addLuaEvent("PACK_UPDATE", self, self.onPackDataUpdate);
	self:addLuaEvent("MarryChildrenSolveItemSelect", self, self.onSelectItemUpdate);
end

function Lua_MarryChildSolveWindow:onHelpImgClick(go)
	Lua_WindowUtil.openWin("Lua_RuleTipWindow", WinParam.ACTION_OPEN, LanUtil.getValue(144049));
end

function Lua_MarryChildSolveWindow:onSelectBoxChange(val)
	DataCenter.marryNewData.bChildrenSolveSelectAll = val;
	if self.bSelectAll ~= val then
		self.bSelectAll = val;
		if val == false then
			self.addExp = 0;
			self.expTxt.text = LanUtil.formateStr(LanUtil.getValue(144031), "[f42a2a]"..self.addExp.."[-]");
			self:resetSolveSelect();
		else
			self:updateItemList();
		end
	end
end

function Lua_MarryChildSolveWindow:onSolveBtnClick(go)
	if self.clickTime ~= nil and getTime() - self.clickTime < 0.3 then
		OperateAlert.show(LanUtil.getValue(121419));
		return;
	end
	self.clickTime = getTime();

	if self.addExp <= 0 then
		OperateAlert.show(LanUtil.getValue(144032));
		return;
	end
	Lua_ProxyManager.getProxy("Lua_MarryNewProxy"):sChildrenEquipmentSol();
end

-- 背包更新
function Lua_MarryChildSolveWindow:onPackDataUpdate(packType)
	if packType == Lua_PackData.BAG_PACK then
		self:updateItemList();
	end
end

function Lua_MarryChildSolveWindow:onSelectItemUpdate(num)
	if self.showArr ~= nil then
		local bAll = true;
		local len = self.showArr:getSize();
		for i = 1, len do 
			local vo = self.showArr[i];
			if vo ~= nil and type(vo) ~= "number" then
				if DataCenter.marryNewData:getChildrenSolveSelect(vo.index) == false then
					bAll = false;
					break;
				end
			end
		end

		self.addExp = self.addExp + num;
		if self.addExp > 0 then
			self.expTxt.text = LanUtil.formateStr(LanUtil.getValue(144031), "[048701]"..self.addExp.."[-]");
		else
			self.expTxt.text = LanUtil.formateStr(LanUtil.getValue(144031), "[f42a2a]"..self.addExp.."[-]");
		end

		self.bSelectAll = bAll;
		self.selectBox.seleted = self.bSelectAll;
	end
end

function Lua_MarryChildSolveWindow:resetSolveSelect()
	DataCenter.marryNewData:resetChildrenSolveSelectDic();
	if self.showArr ~= nil then
		self.itemList:setLuaArrayData(self.showArr, false);
	end
	self.bSelectAll = false;
	self.selectBox.seleted = self.bSelectAll;
end

function Lua_MarryChildSolveWindow:updateItemList()
	if self.showArr ~= nil then
		self.showArr:clear();
	end

	local allData = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK).itemIndexList;
	self.showArr = Array();
	for k, v in pairs(allData) do
		if v ~= nil and v.marryChildrenRolveExp > 0 then
			self.showArr:add(v);
		end
	end

	self.addExp = 0;
	DataCenter.marryNewData:resetChildrenSolveSelectDic();
	local len = self.showArr:getSize();
	local vo = nil;
	for i = 1, len do
		vo = self.showArr[i];
		DataCenter.marryNewData:setChildrenSolveSelectDic(vo.index, true);
		self.addExp = self.addExp + vo.marryChildrenRolveExp * vo.count;
	end

	self.bSelectAll = true;
	self.selectBox.seleted = self.bSelectAll;

	if self.addExp > 0 then
		self.expTxt.text = LanUtil.formateStr(LanUtil.getValue(144031), "[00E125]"..self.addExp.."[-]");
	else
		self.expTxt.text = LanUtil.formateStr(LanUtil.getValue(144031), "[FF1616]"..self.addExp.."[-]");
	end

	-- 填满可视区域
	local len = self.showArr:getSize()
	local num = 21 - len;
	if num > 0 then
		for i = 1, num do
			self.showArr:add(num);
		end
	else
		num = Mathf.Round(len / 7) * 7 - len;
		if num > 0 then
			for i = 1, num do
				self.showArr:add(num);
			end
		end
	end
	self.itemList:setLuaArrayData(self.showArr, false);
end

function Lua_MarryChildSolveWindow:dispose()
	if self.showArr ~= nil then
		self.showArr:clear();
		self.showArr = nil;
	end
	self.addExp = 0;
	DataCenter.marryNewData.bChildrenSolveSelectAll = false;
	DataCenter.marryNewData:resetChildrenSolveSelectDic();

	self:superCall("dispose");
end





--------------------------------------------------





Lua_ChildrenSolveListItem = class("Lua_ChildrenSolveListItem", Lua_ListCell);
function Lua_ChildrenSolveListItem:ctor(p)
	self:superCall("ctor", p, "ChildrenSolveListItem_skin");
end

function Lua_ChildrenSolveListItem:buildShowItem()
	self:superCall("buildShowItem");
end

function Lua_ChildrenSolveListItem:setData(data)
	self.data = data;

	if self.data ~= nil and type(self.data) ~= "number" then
		self.bg:setEnable(false);
		if self.item == nil then
			self.item = Lua_ToolImage.new(self.content);
			self.item:setDepth(2);
			self.item:setLocation(0, 0, 0);
			self.item:setCanClick(false);
		end
		self.item.data = self.data;

		if DataCenter.marryNewData.bChildrenSolveSelectAll or DataCenter.marryNewData:getChildrenSolveSelect(self.data.index) then
			self.selectImg:setEnable(true);
			self.selectIcon:setEnable(true);
		else
			self.selectImg:setEnable(false);
			self.selectIcon:setEnable(false);
		end
	else
		if self.item ~= nil then
			self.item:dispose();
			self.item = nil;
		end
		self.bg:setEnable(true);
		self.selectImg:setEnable(false);
		self.selectIcon:setEnable(false);
	end
end

function Lua_ChildrenSolveListItem:onPlayerSoundClick(go)
	if self.data ~= nil and type(self.data) ~= "number" then
		local bSelect = DataCenter.marryNewData:getChildrenSolveSelect(self.data.index);
		self.selectImg:setEnable(not bSelect);
		self.selectIcon:setEnable(not bSelect);

		DataCenter.marryNewData:setChildrenSolveSelectDic(self.data.index, not bSelect);
		local num = not bSelect and self.data.marryChildrenRolveExp * self.data.count or -self.data.marryChildrenRolveExp * self.data.count;
		Lua_MsgUtil.callFunc("MarryChildrenSolveItemSelect", num);
	end
end

function Lua_ChildrenSolveListItem:dispose()
	if self.item ~= nil then
		self.item:dispose();
		self.item = nil;
	end
	self.data = nil;

	self:superCall("dispose");
end