-- 姻缘仙娃升级界面
checkRequire("Lua_MarrySecAttrsListItem");
Lua_MarryChildUpgradeWindow = class("Lua_MarryChildUpgradeWindow", Lua_Window);
function Lua_MarryChildUpgradeWindow:ctor(p)
	self:superCall("ctor", p);

	self.windowName = "Lua_MarryChildUpgradeWindow";
	self.skinName = "MarryChildUpgradeWindow_skin";
	self.bInitBaseAttrs = false;
	self.bInitAddAttrs = false;
end

function Lua_MarryChildUpgradeWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.fightNum = Lua_NumberImage.new(self.content);
	self.fightNum.numWidth = 19;
	self.fightNum.prefix = "a_";
	self.fightNum:setNumScale(0.8, 0.8);
	self.fightNum:setDepth(5);
	self.fightNum:setLocation(218, 230, 0);

	self.baseAttrsList = Lua_DragList.new(self.content, 1, Vector4(0, 0, 340, 161));
	self.baseAttrsList:setLocation(251, 52.5, 0);
	self.baseAttrsList:setListCell(Lua_MarrySecAttrsListItem, 37, 10, 1);

	self.LvAttrsList = Lua_DragList.new(self.content, 1, Vector4(0, 0, 340, 198));
	self.LvAttrsList:setLocation(251, -200, 0);
	self.LvAttrsList:setListCell(Lua_MarrySecAttrsListItem, 37, 10, 1);

	self.upgradeBtn:addClickFuntion(self, self.onUpgradeBtnClick);
	self.solveBtn:addClickFuntion(self, self.onSolveBtnClick);

    -- 2022/10/25 策划需求改动
	self.upgradeBtn:setLocation(-189, -284, 0);
	self.upgradeRedDot:setLocation(-113, -246, 0);
	self.solveBtn:setEnable(false);

	self:addLuaEvent("rMarryChildrenInfo", self, self.onUpdateChildrenInfo);
	self:addLuaEvent("UPDATE_REDDOT_EVENT", self, self.onRedDotUpdate);
	self:onRedDotUpdate(nil);

	if self.data ~= nil then
		if self.bInitBaseAttrs == false then
			self.bInitBaseAttrs = true;
			self:updateBaseAttrs();
		end

		if self.bInitAddAttrs == false then
			self.bInitAddAttrs = true;
			self:updateLvAddAttrs();
			self:showModel();
		end
	end
end

function Lua_MarryChildUpgradeWindow:showWin(param)
	self:superCall("showWin", param);

	Lua_MsgUtil.callFunc("MarryChildUpgradeWindowShowOrHide", true);
	self.data = param;
	self.nameTxt.text = self.data.name;
	if self.baseAttrsList ~= nil then
		self.bInitBaseAttrs = true;
		self:updateBaseAttrs();
	end

	if self.LvAttrsList ~= nil then
		self.bInitAddAttrs = true;
		self:updateLvAddAttrs();
		self:showModel();
	end
end

-- 红点更新
function Lua_MarryChildUpgradeWindow:onRedDotUpdate(obj)
	if obj ~= nil then
		if obj.evenId == 11604 then -- 仙娃分解红点
			self.solveRedDot:setEnable(DataCenter.redDotData:getRedDotStateByEventId(11604));
		elseif obj.evenId == 11605 then -- 仙娃升级红点
			self.upgradeRedDot:setEnable(DataCenter.redDotData:getRedDotStateByEventId(11605));
		end
	else
		self.solveRedDot:setEnable(DataCenter.redDotData:getRedDotStateByEventId(11604));
		self.upgradeRedDot:setEnable(DataCenter.redDotData:getRedDotStateByEventId(11605));
	end
end

function Lua_MarryChildUpgradeWindow:onUpgradeBtnClick(go)
	local lv = DataCenter.marryNewData.marryChildrenLv;
	local curExp = DataCenter.marryNewData.marryChildrenLvExp;
	local vo = DataCenter.marryNewUtil:getChildrenLvInfoVoByLv(lv);
	if vo ~= nil then
		local nextVo = DataCenter.marryNewUtil:getChildrenLvInfoVoByLv(lv + 1);
		if nextVo == nil then -- 等级最大了
			OperateAlert.show(LanUtil.getValue(144034));
			return;
		end

		if curExp < vo.exp then
			OperateAlert.show(LanUtil.getValue(144035));
			return;
		end
		Lua_ProxyManager.getProxy("Lua_MarryNewProxy"):sChildrenUpgrade();
	end
end

function Lua_MarryChildUpgradeWindow:onSolveBtnClick(go)
	Lua_WindowUtil.openWin("Lua_MarryChildSolveWindow", WinParam.ACTION_OPEN, nil);
end

function Lua_MarryChildUpgradeWindow:onUpdateChildrenInfo()
	if self.data ~= nil then
		local data = DataCenter.marryNewUtil.marryChildrenInfo[self.data.id];
		if data ~= nil then
			self.data = data;
			if self.baseAttrsList ~= nil then
				self:updateBaseAttrs();
			end

			if self.LvAttrsList ~= nil then
				self:updateLvAddAttrs();
			end
		end
	end
end

function Lua_MarryChildUpgradeWindow:updateBaseAttrs()
	self.fightNum.num = DataCenter.marryNewData.childrenLvAddForce;

	-- local arr = Array();
	-- local gradeVo = DataCenter.marryNewUtil:getChildGradeVo(self.data.id, self.data.grade);
	-- local list = gradeVo.attrsArr;
	-- for i = 1, list:getSize() do
	-- 	arr:add({name = list[i].name, curValue = list[i].value, nextValue = 0});
	-- end
	-- self.baseAttrsList:setLuaArrayData(arr, false);
	self.baseAttrsList:setLuaArrayData(DataCenter.marryNewUtil.allChildrenGradeAttrs, false);
end

function Lua_MarryChildUpgradeWindow:updateLvAddAttrs()
	local lv = DataCenter.marryNewData.marryChildrenLv;
	local curExp = DataCenter.marryNewData.marryChildrenLvExp;
	local vo = DataCenter.marryNewUtil:getChildrenLvInfoVoByLv(lv);
	if vo ~= nil then
		self.lvTxt.text = "Lv."..lv;
		self.expBar:setText(curExp.."/"..vo.exp);
		self.expBar:setMaxValue(vo.exp);
		self.expBar:setValue(curExp);

		local nextVo = DataCenter.marryNewUtil:getChildrenLvInfoVoByLv(lv + 1);
		local list;
		local arr = Array();
		if nextVo == nil then -- 等级最大了
			list = vo.attrsArr;
			for i = 1, list:getSize() do
				arr:add({name = list[i].name, curValue = list[i].value, nextValue = 0});
			end
		else -- 有下一阶
			list = vo.attrsArr;
			local num;
			for i = 1, list:getSize() do
				num = nextVo.attrsDic[list[i].name] ~= nil and nextVo.attrsDic[list[i].name] - list[i].value or 0;
				arr:add({name = list[i].name, curValue = list[i].value, nextValue = num});
			end

			-- 防止下一阶有，而当前阶没有情况
			list = nextVo.attrsArr;
			for i = 1, list:getSize() do
				num = vo.attrsDic[list[i].name];
				if num == nil then
					arr:add({name = list[i].name, curValue = 0, nextValue = list[i].value});
				end
			end
		end
		self.LvAttrsList:setLuaArrayData(arr, false);
	end
end

function Lua_MarryChildUpgradeWindow:showModel()
	if self.data == nil then
		if self.modelTexture ~= nil then
			self.modelTexture:dispose();
			self.modelTexture = nil;
		end
		return;
	end

	-- 这部分太多代码，参考侍宠的，有空优化
	if self.modelTexture == nil then
		self.modelTexture = UIModelTexture();
		self.modelTexture:init(self.content, Vector2(-122, -89), Vector2(1175, 680), 3, Vector3(0, 180, 0), Vector2(-150, -145), 360);
		self.modelTexture:setRotEnable(true, -198 + 122, 15 + 89, 450, 400, 2);
		self.rootPos = self.modelTexture.root.transform.localPosition;
		self.rootRot = self.modelTexture.root.transform.localEulerAngles;
		self.rootSca = self.modelTexture.root.transform.localScale;
		self.effectPos = self.modelTexture.uiEffect.mainContent.transform.localPosition;
		self.effectRot = self.modelTexture.uiEffect.mainContent.transform.localEulerAngles;
		self.effectSca = self.modelTexture.uiEffect.mainContent.transform.localScale;
	end

	if self.curModelId ~= self.data.shapeId then
		self.curModelId = self.data.shapeId;
		local modelInfo = DataCenter.servantData:getModelInfo(self.data.shapeId);
		if modelInfo == nil then
			if self.modelTexture ~= nil then
				self.modelTexture:dispose();
				self.modelTexture = nil;
			end
			return;
		end
		self.modelTexture:setUrl(modelInfo.floder .. "/" .. modelInfo.fileName, tostring(modelInfo.modelName));

		local rootPos;
		if modelInfo.rootPos == nil then
			rootPos = self.rootPos;
		else
			rootPos = Vector3(modelInfo.rootPos[1], modelInfo.rootPos[2], modelInfo.rootPos[3]);
		end

		local rootRot;
		if modelInfo.rootRot == nil then
			rootRot = self.rootRot;
		else
			rootRot = Vector3(modelInfo.rootRot[1], modelInfo.rootRot[2], modelInfo.rootRot[3]);
		end

		local rootSca;
		if modelInfo.rootSca == nil then
			rootSca = self.rootSca;
		else
			rootSca = Vector3(modelInfo.rootSca[1], modelInfo.rootSca[2], modelInfo.rootSca[3]);
		end

		local effectPos;
		if modelInfo.pos == nil then
			effectPos = self.effectPos;
		else
			effectPos = Vector3(modelInfo.pos[1], modelInfo.pos[2], modelInfo.pos[3]);
		end

		local effectRot;
		if modelInfo.rot == nil then
			effectRot = self.effectRot;
		else
			effectRot = Vector3(modelInfo.rot[1], modelInfo.rot[2], modelInfo.rot[3]);
		end

		local effectSca;
		if modelInfo.sca == nil then
			effectSca = self.effectSca;
		else
			effectSca = Vector3(modelInfo.sca[1], modelInfo.sca[2], modelInfo.sca[3]);
		end
		self.modelTexture:setEffectPos(effectPos.x, effectPos.y, effectPos.z);
		self.modelTexture:setModelAngle(effectRot.x, effectRot.y, effectRot.z);
		self.modelTexture:setModelOffset(rootPos.x, rootPos.y, rootPos.z);
		self.modelTexture.uiEffect:setSacle(effectSca.x, effectSca.y, effectSca.z);
		-- self.modelTexture.root.transform.localEulerAngles = rootRot;
		-- self.modelTexture.root.transform.localScale = rootSca;
	    LuaUtil.setObjRot(self.modelTexture.root, rootRot.x, rootRot.y, rootRot.z);
		LuaUtil.setObjScale(self.modelTexture.root, rootSca.x, rootSca.y, rootSca.z);
	end
end

function Lua_MarryChildUpgradeWindow:dispose()
	if self.fightNum ~= nil then
		self.fightNum:dispose();
		self.fightNum = nil;
	end
	if self.baseAttrsList ~= nil then
		self.baseAttrsList:dispose();
		self.baseAttrsList = nil;
	end
	if self.LvAttrsList ~= nil then
		self.LvAttrsList:dispose();
		self.LvAttrsList = nil;
	end
	if self.modelTexture ~= nil then
		self.modelTexture:dispose();
		self.modelTexture = nil;
	end
	self.bInitBaseAttrs = false;
	self.bInitAddAttrs = false;
	Lua_MsgUtil.callFunc("MarryChildUpgradeWindowShowOrHide", false);

	self:superCall("dispose");
end