Lua_MarryCopyInfoPanel = class("Lua_MarryCopyInfoPanel", Lua_DisplayObject);
function Lua_MarryCopyInfoPanel:ctor(p)
	self:superCall("ctor", p, "MarryCopyInfoPanel_skin", true);
end

function Lua_MarryCopyInfoPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.descBg.imgTypeNum = 4;
	self.descBg.widget.border = Vector4(0, 10, 0, 10);

	self.copyVo = DataCenter.copyData:getCopyById(Lua_CopyData.YINYUAN_COPY);
	self.descTxt.text = self.copyVo.des;

	local difData = getConfig({self.copyVo.another_config, 2000000 + 1000 * self.copyVo.script_type + 1});
	local arr = Array();
	if difData ~= nil and difData.reward ~= nil then
		arr:add(difData.reward[1]);
	end
	self.rewardItem = Lua_RewardItem.new(self.content);
	self.rewardItem.pivot = 2;
	self.rewardItem:setDepth(5);
	self.rewardItem:setClickWin(true);
	self.rewardItem:setLocation(360, -146, 0);
	self.rewardItem:setRewardByRewardList(arr);

	-- self.helpImg:addClickFuntion(self, self.onHelpImgClick);
	self.addBtn:addClickFuntion(self, self.onAddBtnClick);
	self.inviteBtn:addClickFuntion(self, self.onInviteBtnClick);
	self.challengeBtn:addClickFuntion(self, self.onChallengeBtnClick);

	self:updateCopyInfo();

	self:addLuaEvent("COPY_DATA_UPDATE", self, self.onCopyDataUpdate);
	Lua_CopyUtil.sendGetCopyInfoMsg(Lua_CopyData.YINYUAN_COPY);
end

function Lua_MarryCopyInfoPanel:onHelpImgClick(go)
	Lua_WindowUtil.openWin("Lua_RuleTipWindow", WinParam.ACTION_OPEN, LanUtil.getValue(144052));
end

function Lua_MarryCopyInfoPanel:onAddBtnClick(go)
	local t = self.copyVo.leftBuyTimes;
	if t == nil then
		t = 0;
	end
	local info = {};
	info.owner = self;
	info.configSign = self.copyVo.vip_index;
	info.residueTimes = t;
	info.costList = self.copyVo:getBuyTimeCostList();
	info.costType = self.copyVo:getBuyTimeCostType();
	info.useGold = 1;
	info.callback = self.onBuyTimes;
	Lua_WindowUtil.openWin("Lua_CopyYinYuanTipsWindow", WinParam.ACTION_OPEN, info);
end

function Lua_MarryCopyInfoPanel:onBuyTimes()
	Lua_CopyUtil.buyCopyTime(self.copyVo.id, 1)
end

-- 邀请
function Lua_MarryCopyInfoPanel:onInviteBtnClick(go)
	if DataCenter.roleData.partnerId == nil or DataCenter.roleData.partnerId == 0 then
		OperateAlert.show(LanUtil.getValue(144051));
		return;
	end

	local td = DataCenter.teamData;
	if td.hasTeam == false then
		td:setTeamTargetByCopy(self.copyVo.script_type, 1, false);
		td.minLv = 1;
		td.maxLv = 999;
		td:createTeam();
	else
		if td.amILeader == true and td.targetVo.script_type ~= self.copyVo.script_type then
			Lua_ProxyManager.getProxy("Lua_TeamProxy"):sSetTeamTarget(3, td.minLv, td.maxLv, self.copyVo.script_type, 1);
		end
	end

	Lua_ProxyManager.getProxy("Lua_TeamProxy"):sInviteAndApplyTeam(DataCenter.roleData.partnerId, 1);
	OperateAlert.show(LanUtil.getValue(144055));
end

-- 挑战
function Lua_MarryCopyInfoPanel:onChallengeBtnClick(go)
	if DataCenter.roleData.partnerId == nil or DataCenter.roleData.partnerId == 0 then
		OperateAlert.show(LanUtil.getValue(144051));
		return;
	end

	local td = DataCenter.teamData;
	if td.hasTeam == false then
		OperateAlert.show(LanUtil.getValue(121187));
	else
		if td.amILeader == true then
			td:enterCopy(self.copyVo.script_type, 1);
		else
			OperateAlert.show(LanUtil.getValue(122241));
		end
	end
end

function Lua_MarryCopyInfoPanel:onCopyDataUpdate(o)
	self:updateCopyInfo();
end

function Lua_MarryCopyInfoPanel:updateCopyInfo()
	self.copyVo = DataCenter.copyData:getCopyById(Lua_CopyData.YINYUAN_COPY);

	local leftTimes = self.copyVo.leftTimes;
	if leftTimes == nil or leftTimes <= 0 then
		leftTimes = 0;
		str = "[FF1616]"..leftTimes.."[-]";
	else
		str = "[00E125]"..leftTimes.."[-]";
	end
	self.residueChallgeNum.text = LanUtil.formateStr(LanUtil.getValue(144053), str);

	local leftBuyTimes = self.copyVo.leftBuyTimes;
	if leftBuyTimes == nil or leftBuyTimes <= 0 then
	leftBuyTimes = 0;
		str = "[FF1616]"..leftBuyTimes.."[-]";
	else
		str = "[00E125]"..leftBuyTimes.."[-]";
	end
	self.residueBuyNum.text = LanUtil.formateStr(LanUtil.getValue(144054), str);

	local posX = self.residueBuyNum.mainContent.transform.localPosition.x + self.residueBuyNum.width + 27.5;
	if posX <= self.addBtn.mainContent.transform.localPosition.x then
		posX = self.addBtn.mainContent.transform.localPosition.x;
	end
	self.addBtn:setLocation(posX, self.residueBuyNum.mainContent.transform.localPosition.y, 0);

	self:showEffect(leftBuyTimes > 0 and leftTimes <= 0, posX);
end

-- 增加次数特效
function Lua_MarryCopyInfoPanel:showEffect(val, posX)
	if val == true then
		if self.hangEffect == nil then
			self.hangEffect = UICreate.createUIEffect(self.content, "/effects/scsEffects/gui_guajishijian", "gui_guajishijian", posX, -267);
			self.hangEffect:setLoop(true);
			self.hangEffect:setSacle(1, 1, 1);
			self.hangEffect:SetRenderQueue(self.addBtn, 11, 2, false);
			-- self.hangEffect.mainContent.transform.localRotation = Quaternion.Euler(0, 0, 45);
			LuaUtil.setObjRot(self.hangEffect.mainContent, 0, 0, 45);
		end
		self.hangEffect:setEnable(true);
	else
		if self.hangEffect ~= nil then
			self.hangEffect:setEnable(false);
		end
	end
end

function Lua_MarryCopyInfoPanel:dispose()
	if self.rewardItem ~= nil then
		self.rewardItem:dispose();
		self.rewardItem = nil;
	end
	if self.hangEffect ~= nil then
		self.hangEffect:dispose();
		self.hangEffect = nil;
	end

	self:superCall("dispose");
end