Lua_MarryGiftBoxPanel = class("Lua_MarryGiftBoxPanel", Lua_DisplayObject);
function Lua_MarryGiftBoxPanel:ctor(p)
	self:superCall("ctor", p, "MarryGiftBoxPanel_skin", true);
end

function Lua_MarryGiftBoxPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.boxRedDot1:setEnable(false);
	self.boxRedDot2:setEnable(false);

	local rewardId = getConfig( {"wedding_treasures", 1, "day_reward"});
	if rewardId == nil then
		rewardId = 12402;
	end
	self.rewardItem = Lua_RewardItem.new(self.content);
	self.rewardItem:setMaxShow(5);
	self.rewardItem:setClickWin(true);
	self.rewardItem:setMouseEnble(true);
	self.rewardItem:setDepth(self.depth + 10);
	self.rewardItem:setLayout(100, 80, 5);
	self.rewardItem:setLocation(-195, 60, 0);
	self.rewardItem:setRewardByRewardList(Array(rewardId));

	self.helpTxt.text = LanUtil.getValue(144071);
	self.descTxt.text = LanUtil.getValue(144072);

	self.descTxt.clickScale = false;
	self.getBuyGiftBtn.clickScale = false;
	self.getEveryDayBtn.clickScale = false;

	self:updateRoleModel();
	self:updatePanelInfo();

	self.helpImg:addClickFuntion(self, self.onHelpImgClick);
	-- self.helpImg2:addClickFuntion(self, self.onHelpImg2Click);
	self.descTxt:addClickFuntion(self, self.onRequestClick);
	self.getBuyGiftBtn:addClickFuntion(self, self.onGetBuyGiftBtnClick);
	self.getEveryDayBtn:addClickFuntion(self, self.onGetEveryDayClick);
	self.buyBtn:addClickFuntion(self, self.onBuyBtnClick);

	self:addLuaEvent("rMarryInfo", self, self.onUpdateInfoHandler);
end

function Lua_MarryGiftBoxPanel:onHelpImgClick(go)
	Lua_WindowUtil.openWin("Lua_RuleTipWindow", WinParam.ACTION_OPEN, LanUtil.getValue(144074));
end

function Lua_MarryGiftBoxPanel:onHelpImg2Click(go)
	Lua_WindowUtil.openWin("Lua_RuleTipWindow", WinParam.ACTION_OPEN, LanUtil.getValue(144075));
end

-- 请求赠送
function Lua_MarryGiftBoxPanel:onRequestClick(go)
	if DataCenter.marryNewData.bMarried == false then
		OperateAlert.show(LanUtil.getValue(144051));
		return;
	end

	local ownBoxInfo = DataCenter.marryNewData.ownBoxInfo;
	if ownBoxInfo == nil or tonumber(ownBoxInfo.buy_tick) == 0 then
		Lua_ProxyManager.getProxy("Lua_MarryNewProxy"):sBuyLoveGiftBox(2);
		OperateAlert.show(LanUtil.getValue(144080));
	end
end

-- 购买立得
function Lua_MarryGiftBoxPanel:onGetBuyGiftBtnClick(go)
	if DataCenter.marryNewData.bMarried == false then
		OperateAlert.show(LanUtil.getValue(144051));
		return;
	end

	local ownBoxInfo = DataCenter.marryNewData.ownBoxInfo;
	if ownBoxInfo == nil or tonumber(ownBoxInfo.buy_tick) == 0 then
		OperateAlert.show(LanUtil.getValue(144076));
		return;
	else
		if tonumber(ownBoxInfo.once_reward) == 1 then -- 已领取
			OperateAlert.show(LanUtil.getValue(144078));
			return;
		end
	end
	
	Lua_ProxyManager.getProxy("Lua_MarryNewProxy"):sGetLoveGiftBox(1);
end

-- 每天可领
function Lua_MarryGiftBoxPanel:onGetEveryDayClick(go)
	if DataCenter.marryNewData.bMarried == false then
		OperateAlert.show(LanUtil.getValue(144051));
		return;
	end

	local ownBoxInfo = DataCenter.marryNewData.ownBoxInfo;
	if ownBoxInfo == nil or tonumber(ownBoxInfo.buy_tick) == 0 then
		OperateAlert.show(LanUtil.getValue(144076));
		return;
	else
		if tonumber(ownBoxInfo.day_reward) == 1 then -- 已领取
			OperateAlert.show(LanUtil.getValue(144077));
			return;
		end
	end

	Lua_ProxyManager.getProxy("Lua_MarryNewProxy"):sGetLoveGiftBox(2);
end

-- 为他购买
function Lua_MarryGiftBoxPanel:onBuyBtnClick(go)
	if DataCenter.marryNewData.bMarried == false then
		OperateAlert.show(LanUtil.getValue(144051));
		return;
	end

	local otherBoxInfo = DataCenter.marryNewData.otherBoxInfo;
	if otherBoxInfo ~= nil and tonumber(otherBoxInfo.buy_tick) ~= 0 then
		OperateAlert.show(LanUtil.getValue(144079));
		return;
	end

	local tipData = {};
	tipData.des = LanUtil.formateStr(LanUtil.getValue(124138),tostring(DataCenter.marryNewUtil.loveGiftGold));
	tipData.owner = self;
	tipData.type = 1;
	tipData.subFun = self.onAgree;
	Lua_WindowUtil.openWin("Lua_TipsWindow", nil, tipData);
end

function Lua_MarryGiftBoxPanel:onAgree()
	--检查元宝是否足够
	if DataCenter.moneyData:isMoneyEnough(Lua_MoneyData.GOLD_AND_BINDGOLD, DataCenter.marryNewUtil.loveGiftGold, false, true) then 
		Lua_ProxyManager.getProxy("Lua_MarryNewProxy"):sBuyLoveGiftBox(1);
	end
end

-- 结婚信息变更
function Lua_MarryGiftBoxPanel:onUpdateInfoHandler()
	self:updateRoleModel();
	self:updatePanelInfo();
end

function Lua_MarryGiftBoxPanel:updateRoleModel()
	local marryNewData = DataCenter.marryNewData;
	local spouseInfo = marryNewData.spouseInfo;
	if marryNewData.bMarried == false or spouseInfo == nil then
		if self.playerModel ~= nil then
			self.playerModel:dispose();
			self.playerModel = nil;
		end
		self.roleName.text = "";
		return;
	end
	self.roleName.text = spouseInfo.role_name;

	local modelData = UsData();
	modelData.roleId = spouseInfo.role_id; -- 
	modelData.nickname = spouseInfo.role_name; -- 
	modelData.gender = spouseInfo.sex; -- 性别
	modelData.career = spouseInfo.career; -- 职业
	modelData.profession = spouseInfo.profession; -- 当前转职次数
	modelData.weapon_id = marryNewData.weapon; -- 武器
	modelData.clothes_id = marryNewData.fashion; -- 衣服
	modelData.fashion_weapon_id = marryNewData.fashion_weapon_id; -- 
	modelData.fashion_clothes_id = marryNewData.fashion_clothes_id; -- 
	modelData.fashionHeadId = marryNewData.fashion_headgear_id; -- 
	modelData.wingId = marryNewData.wingId; -- 仙羽等级
	modelData.showShadow = false;
	modelData.canBeClick = false;
	modelData.isShowName = false;
	modelData.IsUI = true;
	modelData.hp = 1;
	modelData.kind = 1;

	if self.playerModel == nil then
		self.playerModel = ModelPlayer();
	end
	self.playerModel:init(self.content, Vector3(286, -120, 0), Vector3(0, 90, 0), modelData, nil, 200);
	self.playerModel:setRotEnable(true, 0, 150, 250, 350, 2);
	self.playerModel:SetRenderQueue(self.roleBg, 0, 3); 
end

function Lua_MarryGiftBoxPanel:updatePanelInfo()
	local time;
	local str;
	local ownBoxInfo = DataCenter.marryNewData.ownBoxInfo;
	local buy_tick = tonumber(tostring(ownBoxInfo.buy_tick));
	if buy_tick == 0 then
		self.timeTxt.text = LanUtil.getValue(124167);
		self.descTxt.text = LanUtil.getValue(144072);

		self.getBuyGiftBtn:setAltas("yinyuan_altas", "ui_marriage_btn_04");
		self.getBuyGiftTxt.text = LanUtil.getValue(122527);

		self.getEveryDayBtn:setAltas("yinyuan_altas", "ui_marriage_btn_04");
		self.getEveryDayTxt.text = LanUtil.getValue(122527);
	else
		time = tonumber(ownBoxInfo.left_time) - tonumber(tostring(GlobalVar.cur_tick))
		str =  TimeTransform.getInstance():transTimeLeft(time);
		self.timeTxt.text = LanUtil.formateStr(LanUtil.getValue(124140), tostring(str));
		self.descTxt.text = LanUtil.getValue(144073);

		if tonumber(ownBoxInfo.once_reward) == 1 then -- 已领取
			self.getBuyGiftBtn:setAltas("yinyuan_altas", "ui_marriage_btn_04");
			self.getBuyGiftTxt.text = LanUtil.getValue(122528);
			self.boxRedDot1:setEnable(false);
		else
			self.getBuyGiftBtn:setAltas("yinyuan_altas", "ui_marriage_btn_03");
			self.getBuyGiftTxt.text = LanUtil.getValue(122527);
			self.boxRedDot1:setEnable(true);
		end

		if tonumber(ownBoxInfo.day_reward) == 1 then -- 已领取
			self.getEveryDayBtn:setAltas("yinyuan_altas", "ui_marriage_btn_04");
			self.getEveryDayTxt.text = LanUtil.getValue(122528);
			self.boxRedDot2:setEnable(false);
		else
			self.getEveryDayBtn:setAltas("yinyuan_altas", "ui_marriage_btn_03");
			self.getEveryDayTxt.text = LanUtil.getValue(122527);
			self.boxRedDot2:setEnable(true);
		end
	end

	local otherBoxInfo = DataCenter.marryNewData.otherBoxInfo;
	buy_tick = tonumber(tostring(otherBoxInfo.buy_tick));
	if buy_tick ~= 0 then
		time = tonumber(otherBoxInfo.left_time) - tonumber(tostring(GlobalVar.cur_tick))
		str = TimeTransform.getInstance():transTimeLeft(time);
		self.buyTipTxt.text = LanUtil.formateStr(LanUtil.getValue(144069), tostring(str));
		self.buyBtn:setGray(true);
	else
		self.buyTipTxt.text = LanUtil.getValue(144070);
		self.buyBtn:setGray(false);
	end
end

function Lua_MarryGiftBoxPanel:dispose()
	if self.rewardItem ~= nil then
		self.rewardItem:dispose();
		self.rewardItem = nil;
	end
	if self.playerModel ~= nil then
		self.playerModel:dispose();
		self.playerModel = nil;
	end

	self:superCall("dispose");
end