-- 姻缘-称号
Lua_MarryTitleShowWindow = class("Lua_MarryTitleShowWindow", Lua_ThirdSizeWindow);
function Lua_MarryTitleShowWindow:ctor()
	self:superCall("ctor", true, 3500, true, LanUtil.getValue(144096), true);

	self.windowName = "Lua_MarryTitleShowWindow";
	self.skinName = "MarryTitleShowWindow_skin";
	self.w = 600;
	self.h = 406;
	self.isClickClose = true;
end

function Lua_MarryTitleShowWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.helpTxt.text = LanUtil.getValue(144097);

	self.dragList = Lua_DragList.new(self.content, 1, Vector4(0, 0, 554, 270));
	self.dragList:setLocation(0, -4, 0);
	self.dragList:setListCell(Lua_MarryTitleShowItem, 118, 554, 1);

	self:onUpdateMarryInfo();

	self.helpImg:addClickFuntion(self, self.onHelpImgClick);
	self:addLuaEvent("rMarryInfo", self, self.onUpdateMarryInfo);
end

function Lua_MarryTitleShowWindow:onHelpImgClick(go)
	Lua_WindowUtil.openWin("Lua_RuleTipWindow", WinParam.ACTION_OPEN, LanUtil.getValue(144098));
end

function Lua_MarryTitleShowWindow:onUpdateMarryInfo()
	self.dragList:setLuaArrayData(DataCenter.marryNewUtil.marryTitleArr, false);
end

function Lua_MarryTitleShowWindow:dispose()
	if self.dragList ~= nil then
		self.dragList:dispose();
		self.dragList = nil;
	end
	
	self:superCall("dispose");
end





--------------------------------------------------





Lua_MarryTitleShowItem = class("Lua_MarryTitleShowItem", Lua_ListCell);
function Lua_MarryTitleShowItem:ctor(p)
	self:superCall("ctor", p, "MarryTitleShowItem_skin");
end

function Lua_MarryTitleShowItem:buildShowItem()
	self:superCall("buildShowItem");

	self.inViewEffect = false;
end

function Lua_MarryTitleShowItem:setData(data)
	self.data = data;
	if data == nil then
		return;
	end

	local titleData = data.titleData;
	if titleData.effect == nil then
		self.titleImg:setEnable(true);
		self.titleImg:setAltas(tostring(titleData.atlas), tostring(titleData.referenceId));
		self.titleImg:resetSize();

		if self.rsEffect ~= nil then
			self.rsEffect:dispose();
			self.rsEffect = nil;
		end
	else
		self.titleImg:setEnable(false);

		if self.rsEffect == nil then
			self.rsEffect = UICreate.createUIEffect(self.content, "/effects/scsEffects/"..titleData.effect, titleData.effect, 0, 0);
		end
		self.rsEffect:setUrl("/effects/scsEffects/"..titleData.effect,titleData.effect);
		self.rsEffect:SetRenderQueue(self.bg, 4, 2, false);
		self.rsEffect:setLocation(-191, 0, 0);
		self.rsEffect:setSacle(250, 250, 250);
		-- print(self.rsEffect.height);

		self:updateEffectState();
	end

	self.bar:setText(data.activeProgress.."%");
    self.bar:setMaxValue(100);
    self.bar:setValue(data.activeProgress);
	self.tipsTxt.text = data.activeDesc;
end

function Lua_MarryTitleShowItem:checkOutBound(showRect)
	if self.data == nil or self.data.titleData.effect == nil then
		return;
	end

	local rect = Lua_Rectangle.new(self.itemX, self.itemY - self.rsEffect.height, self.bg.width / 2, self.bg.height / 2);
	self.inViewEffect = showRect:containeRect(rect);
	self:updateEffectState();
end

function Lua_MarryTitleShowItem:updateEffectState()
	if self.rsEffect ~= nil then
		self.rsEffect:setEnable(self.inViewEffect);
	end
end

function Lua_MarryTitleShowItem:dispose()
	if self.rsEffect ~= nil then
		self.rsEffect:dispose();
		self.rsEffect = nil;
	end
	self.data = nil;

	self:superCall("dispose");
end